Attribute VB_Name = "modLexers"
Option Explicit

' This module is very simplistic
' It's only purpose is to create and populate an array with each lexer's
' available style's and what they are called.

Public LexList(100) As String
Public LexName(100) As String

Public Function InitLexerInterface() As Boolean
  ' This function will populate the lexers with the style
  ' names.
  On Error GoTo errHandler:
  InitLexerInterface = True
  LexName(0) = "SCLEX_DEFAULT"
  LexList(0) = String(128, ":")
  LexName(1) = "SCLEX_NULL"
  LexList(1) = ""
  LexName(2) = "SCLEX_PYTHON"
  LexList(2) = "DEFAULT:COMMENTLINE:NUMBER:STRING:CHARACTER:WORD:TRIPLE:TRIPLEDOUBLE:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER:COMMENTBLOCK:STRINGEOL:WORD2:DECORATOR:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(3) = "SCLEX_CPP"
  LexList(3) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:STRING:CHARACTER:UUID:PREPROCESSOR:OPERATOR:IDENTIFIER:STRINGEOL:VERBATIM:REGEX:COMMENTLINEDOC:WORD2:COMMENTDOCKEYWORD:COMMENTDOCKEYWORDERROR:GLOBALCLASS:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(4) = "SCLEX_HTML"
  LexList(4) = "DEFAULT:TAG:TAGUNKNOWN:ATTRIBUTE:ATTRIBUTEUNKNOWN:NUMBER:DOUBLESTRING:SINGLESTRING:OTHER:COMMENT:ENTITY:TAGEND:XMLSTART:XMLEND:SCRIPT:ASP:ASPAT:CDATA:QUESTION:VALUE:XCCOMMENT:SGML_DEFAULT:SGML_COMMAND:SGML_1ST_PARAM:SGML_DOUBLESTRING:SGML_SIMPLESTRING:SGML_ERROR:SGML_SPECIAL:SGML_ENTITY:SGML_COMMENT:SGML_1ST_PARAM_COMMENT:SGML_BLOCK_DEFAULT:::::::::START:DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:KEYWORD:DOUBLESTRING:SINGLESTRING:SYMBOLS:STRINGEOL:REGEX:::START:DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:KEYWORD:DOUBLESTRING:SINGLESTRING:SYMBOLS:STRINGEOL:REGEX:::START:DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:IDENTIFIER:STRINGEOL:::START:DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:IDENTIFIER:STRINGEOL:::START:DEFAULT:COMMENTLINE:NUMBER:STRING:CHARACTER:WORD:TRIPLE:TRIPLEDOUBLE:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER::COMPLEX_VARIABLE:START:DEFAULT:COMMENTLINE:NUMBER:STRING:CHARACTER:WORD:TRIPLE:TRIPLEDOUBLE:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER:DEFAULT:HSTRING:SIMPLESTRING:WORD:NUMBER:"
  LexList(4) = LexList(4) & "VARIABLE:COMMENT:COMMENTLINE:HSTRING_VARIABLE:OPERATOR:"
  LexName(5) = "SCLEX_XML"
  LexList(5) = "DEFAULT:TAG:TAGUNKNOWN:ATTRIBUTE:ATTRIBUTEUNKNOWN:NUMBER:DOUBLESTRING:SINGLESTRING:OTHER:COMMENT:ENTITY:TAGEND:XMLSTART:XMLEND:SCRIPT:ASP:ASPAT:CDATA:QUESTION:VALUE:XCCOMMENT:SGML_DEFAULT:SGML_COMMAND:SGML_1ST_PARAM:SGML_DOUBLESTRING:SGML_SIMPLESTRING:SGML_ERROR:SGML_SPECIAL:SGML_ENTITY:SGML_COMMENT:SGML_1ST_PARAM_COMMENT:SGML_BLOCK_DEFAULT:::::::::START:DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:KEYWORD:DOUBLESTRING:SINGLESTRING:SYMBOLS:STRINGEOL:REGEX:::START:DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:KEYWORD:DOUBLESTRING:SINGLESTRING:SYMBOLS:STRINGEOL:REGEX:::START:DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:IDENTIFIER:STRINGEOL:::START:DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:IDENTIFIER:STRINGEOL:::START:DEFAULT:COMMENTLINE:NUMBER:STRING:CHARACTER:WORD:TRIPLE:TRIPLEDOUBLE:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER::COMPLEX_VARIABLE:START:DEFAULT:COMMENTLINE:NUMBER:STRING:CHARACTER:WORD:TRIPLE:TRIPLEDOUBLE:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER:DEFAULT:HSTRING:SIMPLESTRING:WORD:NUMBER:"
  LexList(5) = LexList(5) & "VARIABLE:COMMENT:COMMENTLINE:HSTRING_VARIABLE:OPERATOR:"
  LexName(6) = "SCLEX_PERL"
  LexList(6) = "DEFAULT:ERROR:COMMENTLINE:POD:NUMBER:WORD:STRING:CHARACTER:PUNCTUATION:PREPROCESSOR:OPERATOR:IDENTIFIER:SCALAR:ARRAY:HASH:SYMBOLTABLE:VARIABLE_INDEXER:REGEX:REGSUBST:LONGQUOTE:BACKTICKS:DATASECTION:HERE_DELIM:HERE_Q:HERE_QQ:HERE_QX:STRING_Q:STRING_QQ:STRING_QX:STRING_QR:STRING_QW:POD_VERB:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(7) = "SCLEX_SQL"
  LexList(7) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:STRING:CHARACTER:SQLPLUS:SQLPLUS_PROMPT:OPERATOR:IDENTIFIER::SQLPLUS_COMMENT::COMMENTLINEDOC:WORD2:COMMENTDOCKEYWORD:COMMENTDOCKEYWORDERROR:USER1:USER2:USER3:USER4:QUOTEDIDENTIFIER:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(8) = "SCLEX_VB"
  LexList(8) = "DEFAULT:COMMENT:NUMBER:KEYWORD:STRING:PREPROCESSOR:OPERATOR:IDENTIFIER:DATE:STRINGEOL:KEYWORD2:KEYWORD3:KEYWORD4:CONSTANT:ASM:LABEL:ERROR:HEXNUMBER:BINNUMBER::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(9) = "SCLEX_PROPERTIES"
  LexList(9) = "DEFAULT:COMMENT:SECTION:ASSIGNMENT:DEFVAL::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(10) = "SCLEX_ERRORLIST"
  LexList(10) = "DEFAULT:PYTHON:GCC:MS:CMD:BORLAND:PERL:NET:LUA:CTAG:DIFF_CHANGED:DIFF_ADDITION:DIFF_DELETION:DIFF_MESSAGE:PHP:ELF:IFC:IFORT:ABSF:TIDY:JAVA_STACK::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(11) = "SCLEX_MAKEFILE"
  LexList(11) = "DEFAULT:COMMENT:PREPROCESSOR:IDENTIFIER:OPERATOR:TARGET::::IDEOL:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(12) = "SCLEX_BATCH"
  LexList(12) = "DEFAULT:COMMENT:WORD:LABEL:HIDE:COMMAND:IDENTIFIER:OPERATOR:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(13) = "SCLEX_XCODE"
  LexList(13) = ""
  LexName(14) = "SCLEX_LATEX"
  LexList(14) = "DEFAULT:COMMAND:TAG:MATH:COMMENT::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(15) = "SCLEX_LUA"
  LexList(15) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:STRING:CHARACTER:LITERALSTRING:PREPROCESSOR:OPERATOR:IDENTIFIER:STRINGEOL:WORD2:WORD3:WORD4:WORD5:WORD6:WORD7:WORD8:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(16) = "SCLEX_DIFF"
  LexList(16) = "DEFAULT:COMMENT:COMMAND:HEADER:POSITION:DELETED:ADDED::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(17) = "SCLEX_CONF"
  LexList(17) = "DEFAULT:COMMENT:NUMBER:IDENTIFIER:EXTENSION:PARAMETER:STRING:OPERATOR:IP:DIRECTIVE:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(18) = "SCLEX_PASCAL"
  LexList(18) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:STRING:CHARACTER:UUID:PREPROCESSOR:OPERATOR:IDENTIFIER:STRINGEOL:VERBATIM:REGEX:COMMENTLINEDOC:WORD2:COMMENTDOCKEYWORD:COMMENTDOCKEYWORDERROR:GLOBALCLASS:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(19) = "SCLEX_AVE"
  LexList(19) = "DEFAULT:COMMENT:NUMBER:WORD:::STRING:ENUM:STRINGEOL:IDENTIFIER:OPERATOR:WORD1:WORD2:WORD3:WORD4:WORD5:WORD6::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(20) = "SCLEX_ADA"
  LexList(20) = "DEFAULT:WORD:IDENTIFIER:NUMBER:DELIMITER:CHARACTER:CHARACTEREOL:STRING:STRINGEOL:LABEL:COMMENTLINE:ILLEGAL:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(21) = "SCLEX_LISP"
  LexList(21) = "DEFAULT:COMMENT:NUMBER:KEYWORD:KEYWORD_KW:SYMBOL:STRING::STRINGEOL:IDENTIFIER:OPERATOR:SPECIAL:MULTI_COMMENT::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(22) = "SCLEX_RUBY"
  LexList(22) = "DEFAULT:ERROR:COMMENTLINE:POD:NUMBER:WORD:STRING:CHARACTER:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER:REGEX:GLOBAL:SYMBOL:MODULE_NAME:INSTANCE_VAR:CLASS_VAR:BACKTICKS:DATASECTION:HERE_DELIM:HERE_Q:HERE_QQ:HERE_QX:STRING_Q:STRING_QQ:STRING_QX:STRING_QR:STRING_QW:WORD_DEMOTED:STDIN:STDOUT:::::::::STDERR:UPPER_BOUND:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(23) = "SCLEX_EIFFEL"
  LexList(23) = "DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:CHARACTER:OPERATOR:IDENTIFIER:STRINGEOL::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(24) = "SCLEX_EIFFELKW"
  LexList(24) = "DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:CHARACTER:OPERATOR:IDENTIFIER:STRINGEOL::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(25) = "SCLEX_TCL"
  LexList(25) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:STRING:CHARACTER:UUID:PREPROCESSOR:OPERATOR:IDENTIFIER:STRINGEOL:VERBATIM:REGEX:COMMENTLINEDOC:WORD2:COMMENTDOCKEYWORD:COMMENTDOCKEYWORDERROR:GLOBALCLASS:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(26) = "SCLEX_NNCRONTAB"
  LexList(26) = "DEFAULT:COMMENT:TASK:SECTION:KEYWORD:MODIFIER:ASTERISK:NUMBER:STRING:ENVIRONMENT:IDENTIFIER::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(27) = "SCLEX_BULLANT"
  LexList(27) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:STRING:CHARACTER:UUID:PREPROCESSOR:OPERATOR:IDENTIFIER:STRINGEOL:VERBATIM:REGEX:COMMENTLINEDOC:WORD2:COMMENTDOCKEYWORD:COMMENTDOCKEYWORDERROR:GLOBALCLASS:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(28) = "SCLEX_VBSCRIPT"
  LexList(28) = "DEFAULT:COMMENT:NUMBER:KEYWORD:STRING:PREPROCESSOR:OPERATOR:IDENTIFIER:DATE:STRINGEOL:KEYWORD2:KEYWORD3:KEYWORD4:CONSTANT:ASM:LABEL:ERROR:HEXNUMBER:BINNUMBER::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(29) = "SCLEX_ASP"
  LexList(29) = "DEFAULT:TAG:TAGUNKNOWN:ATTRIBUTE:ATTRIBUTEUNKNOWN:NUMBER:DOUBLESTRING:SINGLESTRING:OTHER:COMMENT:ENTITY:TAGEND:XMLSTART:XMLEND:SCRIPT:ASP:ASPAT:CDATA:QUESTION:VALUE:XCCOMMENT:SGML_DEFAULT:SGML_COMMAND:SGML_1ST_PARAM:SGML_DOUBLESTRING:SGML_SIMPLESTRING:SGML_ERROR:SGML_SPECIAL:SGML_ENTITY:SGML_COMMENT:SGML_1ST_PARAM_COMMENT:SGML_BLOCK_DEFAULT:::::::::START:DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:KEYWORD:DOUBLESTRING:SINGLESTRING:SYMBOLS:STRINGEOL:REGEX:::START:DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:KEYWORD:DOUBLESTRING:SINGLESTRING:SYMBOLS:STRINGEOL:REGEX:::START:DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:IDENTIFIER:STRINGEOL:::START:DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:IDENTIFIER:STRINGEOL:::START:DEFAULT:COMMENTLINE:NUMBER:STRING:CHARACTER:WORD:TRIPLE:TRIPLEDOUBLE:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER::COMPLEX_VARIABLE:START:DEFAULT:COMMENTLINE:NUMBER:STRING:CHARACTER:WORD:TRIPLE:TRIPLEDOUBLE:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER:DEFAULT:HSTRING:SIMPLESTRING:WORD:"
  LexList(29) = LexList(29) & "NUMBER:VARIABLE:COMMENT:COMMENTLINE:HSTRING_VARIABLE:OPERATOR:"
  LexName(30) = "SCLEX_PHP"
  LexList(30) = "DEFAULT:TAG:TAGUNKNOWN:ATTRIBUTE:ATTRIBUTEUNKNOWN:NUMBER:DOUBLESTRING:SINGLESTRING:OTHER:COMMENT:ENTITY:TAGEND:XMLSTART:XMLEND:SCRIPT:ASP:ASPAT:CDATA:QUESTION:VALUE:XCCOMMENT:SGML_DEFAULT:SGML_COMMAND:SGML_1ST_PARAM:SGML_DOUBLESTRING:SGML_SIMPLESTRING:SGML_ERROR:SGML_SPECIAL:SGML_ENTITY:SGML_COMMENT:SGML_1ST_PARAM_COMMENT:SGML_BLOCK_DEFAULT:::::::::START:DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:KEYWORD:DOUBLESTRING:SINGLESTRING:SYMBOLS:STRINGEOL:REGEX:::START:DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:KEYWORD:DOUBLESTRING:SINGLESTRING:SYMBOLS:STRINGEOL:REGEX:::START:DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:IDENTIFIER:STRINGEOL:::START:DEFAULT:COMMENTLINE:NUMBER:WORD:STRING:IDENTIFIER:STRINGEOL:::START:DEFAULT:COMMENTLINE:NUMBER:STRING:CHARACTER:WORD:TRIPLE:TRIPLEDOUBLE:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER::COMPLEX_VARIABLE:START:DEFAULT:COMMENTLINE:NUMBER:STRING:CHARACTER:WORD:TRIPLE:TRIPLEDOUBLE:CLASSNAME:DEFNAME:OPERATOR:IDENTIFIER:DEFAULT:HSTRING:SIMPLESTRING:WORD:"
  LexList(30) = LexList(30) & "NUMBER:VARIABLE:COMMENT:COMMENTLINE:HSTRING_VARIABLE:OPERATOR:"
  LexName(31) = "SCLEX_BAAN"
  LexList(31) = "DEFAULT:COMMENT:COMMENTDOC:NUMBER:WORD:STRING:PREPROCESSOR:OPERATOR:IDENTIFIER:STRINGEOL:WORD2::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(32) = "SCLEX_MATLAB"
  LexList(32) = "DEFAULT:COMMENT:COMMAND:NUMBER:KEYWORD:STRING:OPERATOR:IDENTIFIER:DOUBLEQUOTESTRING::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(33) = "SCLEX_SCRIPTOL"
  LexList(33) = "DEFAULT:WHITE:COMMENTLINE:PERSISTENT:CSTYLE:COMMENTBLOCK:NUMBER:STRING:CHARACTER:STRINGEOL:KEYWORD:OPERATOR:IDENTIFIER:TRIPLE:CLASSNAME:PREPROCESSOR:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(34) = "SCLEX_ASM"
  LexList(34) = "DEFAULT:COMMENT:NUMBER:STRING:OPERATOR:IDENTIFIER:CPUINSTRUCTION:MATHINSTRUCTION:REGISTER:DIRECTIVE:DIRECTIVEOPERAND:COMMENTBLOCK:CHARACTER:STRINGEOL:EXTINSTRUCTION::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(35) = "SCLEX_CPPNOCASE"
  LexList(35) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:STRING:CHARACTER:UUID:PREPROCESSOR:OPERATOR:IDENTIFIER:STRINGEOL:VERBATIM:REGEX:COMMENTLINEDOC:WORD2:COMMENTDOCKEYWORD:COMMENTDOCKEYWORDERROR:GLOBALCLASS:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(36) = "SCLEX_FORTRAN"
  LexList(36) = "DEFAULT:COMMENT:NUMBER:STRING1:STRING2:STRINGEOL:OPERATOR:IDENTIFIER:WORD:WORD2:WORD3:PREPROCESSOR:OPERATOR2:LABEL:CONTINUATION::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(37) = "SCLEX_F77"
  LexList(37) = "DEFAULT:COMMENT:NUMBER:STRING1:STRING2:STRINGEOL:OPERATOR:IDENTIFIER:WORD:WORD2:WORD3:PREPROCESSOR:OPERATOR2:LABEL:CONTINUATION::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(38) = "SCLEX_CSS"
  LexList(38) = "DEFAULT:TAG:CLASS:PSEUDOCLASS:UNKNOWN_PSEUDOCLASS:OPERATOR:IDENTIFIER:UNKNOWN_IDENTIFIER:VALUE:COMMENT:ID:IMPORTANT:DIRECTIVE:DOUBLESTRING:SINGLESTRING:IDENTIFIER2:ATTRIBUTE::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(39) = "SCLEX_POV"
  LexList(39) = "DEFAULT:COMMENT:COMMENTLINE:NUMBER:OPERATOR:IDENTIFIER:STRING:STRINGEOL:DIRECTIVE:BADDIRECTIVE:WORD2:WORD3:WORD4:WORD5:WORD6:WORD7:WORD8::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(40) = "SCLEX_LOUT"
  LexList(40) = "DEFAULT:COMMENT:NUMBER:WORD:WORD2:WORD3:WORD4:STRING:OPERATOR:IDENTIFIER:STRINGEOL::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(41) = "SCLEX_ESCRIPT"
  LexList(41) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:NUMBER:WORD:STRING:OPERATOR:IDENTIFIER:BRACE:WORD2:WORD3:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(42) = "SCLEX_PS"
  LexList(42) = "DEFAULT:COMMENT:DSC_COMMENT:DSC_VALUE:NUMBER:NAME:KEYWORD:LITERAL:IMMEVAL:PAREN_ARRAY:PAREN_DICT:PAREN_PROC:TEXT:HEXSTRING:BASE85STRING:BADSTRINGCHAR:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(43) = "SCLEX_NSIS"
  LexList(43) = "DEFAULT:COMMENT:STRINGDQ:STRINGLQ:STRINGRQ:FUNCTION:VARIABLE:LABEL:USERDEFINED:SECTIONDEF:SUBSECTIONDEF:IFDEFINEDEF:MACRODEF:STRINGVAR:NUMBER:SECTIONGROUP:PAGEEX:FUNCTIONDEF:COMMENTBOX::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(44) = "SCLEX_MMIXAL"
  LexList(44) = "LEADWS:COMMENT:LABEL:OPCODE:OPCODE_PRE:OPCODE_VALID:OPCODE_UNKNOWN:OPCODE_POST:OPERANDS:NUMBER:REF:CHAR:STRING:REGISTER:HEX:OPERATOR:SYMBOL:INCLUDE:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(45) = "SCLEX_CLW"
  LexList(45) = "DEFAULT:LABEL:COMMENT:STRING:USER_IDENTIFIER:INTEGER_CONSTANT:REAL_CONSTANT:PICTURE_STRING:KEYWORD:COMPILER_DIRECTIVE:RUNTIME_EXPRESSIONS:BUILTIN_PROCEDURES_FUNCTION:STRUCTURE_DATA_TYPE:ATTRIBUTE:STANDARD_EQUATE:ERROR:DEPRECATED::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(46) = "SCLEX_CLWNOCASE"
  LexList(46) = "DEFAULT:LABEL:COMMENT:STRING:USER_IDENTIFIER:INTEGER_CONSTANT:REAL_CONSTANT:PICTURE_STRING:KEYWORD:COMPILER_DIRECTIVE:RUNTIME_EXPRESSIONS:BUILTIN_PROCEDURES_FUNCTION:STRUCTURE_DATA_TYPE:ATTRIBUTE:STANDARD_EQUATE:ERROR:DEPRECATED::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(47) = "SCLEX_LOT"
  LexList(47) = "DEFAULT:HEADER:BREAK:SET:PASS:FAIL:ABORT::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(48) = "SCLEX_YAML"
  LexList(48) = "DEFAULT:COMMENT:IDENTIFIER:KEYWORD:NUMBER:REFERENCE:DOCUMENT:TEXT:ERROR::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(49) = "SCLEX_TEX"
  LexList(49) = "DEFAULT:SPECIAL:GROUP:SYMBOL:COMMAND:TEXT:EXTRA::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(50) = "SCLEX_METAPOST"
  LexList(50) = "DEFAULT:SPECIAL:GROUP:SYMBOL:COMMAND:TEXT:EXTRA::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(51) = "SCLEX_POWERBASIC"
  LexList(51) = "DEFAULT:COMMENT:NUMBER:KEYWORD:STRING:PREPROCESSOR:OPERATOR:IDENTIFIER:DATE:STRINGEOL:KEYWORD2:KEYWORD3:KEYWORD4:CONSTANT:ASM:LABEL:ERROR:HEXNUMBER:BINNUMBER::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(52) = "SCLEX_FORTH"
  LexList(52) = "DEFAULT:COMMENT:COMMENT_ML:IDENTIFIER:CONTROL:KEYWORD:DEFWORD:PREWORD1:PREWORD2:NUMBER:STRING:LOCALE:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(53) = "SCLEX_ERLANG"
  LexList(53) = "DEFAULT:COMMENT:VARIABLE:NUMBER:KEYWORD:STRING:OPERATOR:ATOM:FUNCTION_NAME:CHARACTER:MACRO:RECORD:SEPARATOR:NODE_NAME::::::::::::::::::UNKNOWN:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(54) = "SCLEX_OCTAVE"
  LexList(54) = "::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(55) = "SCLEX_MSSQL"
  LexList(55) = "DEFAULT:COMMENT:LINE_COMMENT:NUMBER:STRING:OPERATOR:IDENTIFIER:VARIABLE:COLUMN_NAME:STATEMENT:DATATYPE:SYSTABLE:GLOBAL_VARIABLE:FUNCTION:STORED_PROCEDURE:DEFAULT_PREF_DATATYPE:COLUMN_NAME_2::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(56) = "SCLEX_VERILOG"
  LexList(56) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTLINEBANG:NUMBER:WORD:STRING:WORD2:WORD3:PREPROCESSOR:OPERATOR:IDENTIFIER:STRINGEOL:::::::USER:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(57) = "SCLEX_KIX"
  LexList(57) = "DEFAULT:COMMENT:STRING1:STRING2:NUMBER:VAR:MACRO:KEYWORD:FUNCTIONS:OPERATOR::::::::::::::::::::::IDENTIFIER:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(58) = "SCLEX_GUI4CLI"
  LexList(58) = String(128, ":")
  LexName(59) = "SCLEX_SPECMAN"
  LexList(59) = "DEFAULT:CODE:COMMENTLINE:COMMENTLINEBANG:NUMBER:WORD:STRING:WORD2:WORD3:PREPROCESSOR:OPERATOR:IDENTIFIER:STRINGEOL:REGEXTAG:SIGNAL:::::USER:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(60) = "SCLEX_AU3"
  LexList(60) = "DEFAULT:COMMENT:COMMENTBLOCK:NUMBER:FUNCTION:KEYWORD:MACRO:STRING:OPERATOR:VARIABLE:SENT:PREPROCESSOR:SPECIAL:EXPAND:COMOBJ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(61) = "SCLEX_APDL"
  LexList(61) = "DEFAULT:COMMENT:COMMENTBLOCK:NUMBER:STRING:OPERATOR:WORD:PROCESSOR:COMMAND:SLASHCOMMAND:STARCOMMAND:ARGUMENT:FUNCTION::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(62) = "SCLEX_BASH"
  LexList(62) = "DEFAULT:ERROR:COMMENTLINE:NUMBER:WORD:STRING:CHARACTER:OPERATOR:IDENTIFIER:SCALAR:PARAM:BACKTICKS:HERE_DELIM:HERE_Q:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(63) = "SCLEX_ASN1"
  LexList(63) = "DEFAULT:COMMENT:IDENTIFIER:STRING:OID:SCALAR:KEYWORD:ATTRIBUTE:DESCRIPTOR:TYPE:OPERATOR::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(64) = "SCLEX_VHDL"
  LexList(64) = "DEFAULT:COMMENT:COMMENTLINEBANG:NUMBER:STRING:OPERATOR:IDENTIFIER:STRINGEOL:KEYWORD:STDOPERATOR:ATTRIBUTE:STDFUNCTION:STDPACKAGE:STDTYPE:USERWORD::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(65) = "SCLEX_CAML"
  LexList(65) = "DEFAULT:IDENTIFIER:TAGNAME:KEYWORD:KEYWORD2:KEYWORD3:LINENUM:OPERATOR:NUMBER:CHAR::STRING:COMMENT:COMMENT1:COMMENT2:COMMENT3:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(66) = "SCLEX_BLITZBASIC"
  LexList(66) = String(128, ":")
  LexName(67) = "SCLEX_PUREBASIC"
  LexList(67) = String(128, ":")
  LexName(68) = "SCLEX_HASKELL"
  LexList(68) = "DEFAULT:X_DEFAULT:PREPROCESSOR:BLOCK_COMMENT:LINE_COMMENT:OPERATOR:KEYWORD:NUMBER:IDENTIFIER:S_STRING:D_STRING:X_STRING:LIB_DIRECTIVE:MSG_PARAM:HTML_TAG:HTML_DEFAULT:HTML_STRING:USER1:USER2:USER3:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(69) = "SCLEX_PHPSCRIPT"
  LexList(69) = String(128, ":")
  LexName(70) = "SCLEX_TADS3"
  LexList(70) = "DEFAULT:X_DEFAULT:PREPROCESSOR:BLOCK_COMMENT:LINE_COMMENT:OPERATOR:KEYWORD:NUMBER:IDENTIFIER:S_STRING:D_STRING:X_STRING:LIB_DIRECTIVE:MSG_PARAM:HTML_TAG:HTML_DEFAULT:HTML_STRING:USER1:USER2:USER3:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(71) = "SCLEX_REBOL"
  LexList(71) = "DEFAULT:COMMENTLINE:COMMENTBLOCK:PREFACE:OPERATOR:CHARACTER:QUOTEDSTRING:BRACEDSTRING:NUMBER:PAIR:TUPLE:BINARY:MONEY:ISSUE:TAG:FILE:EMAIL:URL:DATE:TIME:IDENTIFIER:WORD:WORD2:WORD3:WORD4:WORD5:WORD6:WORD7:WORD8::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(72) = "SCLEX_SMALLTALK"
  LexList(72) = "DEFAULT:STRING:NUMBER:COMMENT:SYMBOL:BINARY:BOOL:SELF:SUPER:NIL:GLOBAL:RETURN:SPECIAL:KWSEND:ASSIGN:CHARACTER:SPEC_SEL::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(73) = "SCLEX_FLAGSHIP"
  LexList(73) = "DEFAULT:COMMENT:COMMENTLINE:COMMENTDOC:COMMENTLINEDOC:COMMENTDOCKEYWORD:COMMENTDOCKEYWORDERROR:KEYWORD:KEYWORD2:KEYWORD3:KEYWORD4:NUMBER:STRING:PREPROCESSOR:OPERATOR:IDENTIFIER:DATE:STRINGEOL:CONSTANT:ASM:LABEL:ERROR:HEXNUMBER:BINNUMBER:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
  LexName(74) = "SCLEX_CSOUND"
  LexList(74) = "COMMENTNUMBEROPERATORINSTRIDENTIFIEROPCODEHEADERSTMTUSERKEYWORDCOMMENTBLOCKPARAMARATE_VARKRATE_VARIRATE_VARGLOBAL_VARSTRINGEOL"
  LexName(75) = "SCLEX_FREEBASIC"
  LexList(75) = String(128, ":")
  LexName(76) = "Blank"
  LexList(76) = String(128, ":")
  Exit Function
errHandler:
  ' Something went wrong so we will just exit the function and set the
  ' value of InitLexerInterface to false
  InitLexerInterface = False
End Function
